/********************************************
   PROGRAMERSKA RADIONICA
        SKOLA RAJAK
------------------------
Primer dinamickog zauzimanja memorije
u razlicitim kolicinama
Autor: Sebastian Novak
Datum: 6.4.2013.
Licenca: Slobodno za upotrebu/modifikaciju
Kontakt: programerska.radionica@gmail.com
               www.rajak.rs
Verzija: 1.0.0
Opis: Primer modela nekih igraca, dela neke
igre, zamislimo da u igri postoje razne vrste
torbi, backpack-ova, koji imaju razlicite
velicine. Pri promeni backpack-a
igracu se menja broj slobodnih mesta u inventaru
samim tim se menja i broj elemenata u nizu
koji predstavlja inventar
*******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define BR_IGRACA 5

// model itema koje igrac moze da ima
struct Item{
    char naziv[20]; //
    char efekat[20];
    int sifraItema;
};

// model igraca
struct Igrac{
    int xp; // na svakih 5000 xp ide lvl++
    int lvl;
    struct Item*  inventar; // dinamicki zauzet inventar, pokazivac na pocetak dinamickog niza
    int brSlobodnihMestaInv; // trenutni broj slobodnih mesta u inventaru
    int brMestaInv; // ukupan broj mesta u inventaru
};


int main(){
    struct Igrac igraci[BR_IGRACA];
    int i;
    struct Item* tempInventar;
    int velicinaInventara; // velicina inventara u bajtima
    int rezultatMain=0;

    // svi igraci pocinju od prvog nivoa, sa 0 xp
    // svi imaju osnovni inventar sa 5 slobodnih mesta
    for(i=0;i<BR_IGRACA;i++){
            igraci[i].lvl = 1;
            igraci[i].xp = 0;
            igraci[i].brMestaInv=5;
            igraci[i].brSlobodnihMestaInv=5;
            igraci[i].inventar = malloc(5*sizeof(Item));
            if(igraci[i].inventar==NULL){
                printf("NEDOVOLJNO MEMORIJE, NEUSPESNA ALOKACIJA ZA INVENTAR!\n");
                rezultatMain=1;
                break; // izlazak iz for petlje
            }
    }

    if(rezultatMain==0){
    // SVA MEMORIJA USPESNO ALOCIRANA
    // DOZVOLJEN RAD PROGRAMA, INACE SE IDE NA KRAJ

        // igrac 0  dobija neki 5000 xp i prelazi na sledeci level
        igraci[0].xp = 5000;
        igraci[0].lvl = 2;
        // dobija vise mesta u inventaru, moramo zauzeti veci niz za iteme
        // samo sto moramo da sacuvamo to sto je imao do sada
        velicinaInventara = sizeof(struct Item) * igraci[0].brMestaInv;
        tempInventar = malloc(velicinaInventara);
        memcpy(tempInventar,igraci[0].inventar, velicinaInventara); // kopiramo sve bajte sa adrese igraca u memoriju na adresi tempInventar
         // broj bajta je definisan velicinom Inventara u bajtima

         // sada mozemo da zauzmemo novi blok memorije, novi inventar za igraca 0
         igraci[0].inventar = malloc (2*velicinaInventara); // dvostruko veci inventar
         igraci[0].brSlobodnihMestaInv+=igraci[0].brMestaInv; // slobodna mesta uvecana
         igraci[0].brMestaInv*=2; // ukupan broj mesta udvostrucen

         // vracanje sadrzaja starog inventara u novi
         memcpy(igraci[0].inventar, tempInventar, velicinaInventara);

        // igrac 0 je sada level 2
        // ima 10 mesta u inventaru
        // sve svoje iteme koje je pre prelaska na novi imao, i dalje ima.
    }

    return rezultatMain;
}
